{  umatrix2 -- examples for pascal units for matrix operations (real and complex)
   Version 20220317
   Copyright (C) 2000-2022 Stefan Ziegenbalg
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 3 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see http://www.gnu.org/licenses/.
!}

uses ucmatrix2;
var a,b,c : matrix;

begin
    am2(a,rmatrix(4,4, [1,0,0,0, 2,3,0,0, 4,5,6,0, 7,8,9,10]));
    am(a,a*trans(a));

    am2(b,Cholesky(a));
    printmatrix(b);
    writeln;
    printmatrix(Inverse(b));
    writeln;
    am2(c,Inverse_l(b));
    printmatrix(c);
    writeln;
    printmatrix(c*a*trans(c));

    writeln; writeln;
    am(a,rmatrix(4,4, [1,1,1,2, 1,2,2,3, 1,2,3,3, 2,3,3,5]));
    am(b,Cholesky(a));
    printmatrix(b);
    writeln;
    printmatrix(Inverse(b));
    writeln;
    am(c,Inverse_l(b));
    printmatrix(c);
    writeln;
    printmatrix(c*a*trans(c));

    free(a);
    free(b);
    free(c);
end.
